var X = Object.defineProperty;
var ee = (t, e, n) => e in t ? X(t, e, { enumerable: !0, configurable: !0, writable: !0, value: n }) : t[e] = n;
var f = (t, e, n) => (ee(t, typeof e != "symbol" ? e + "" : e, n), n);
import { defineComponent as te, ref as C, toRefs as ne, reactive as ie, onMounted as se, onBeforeUnmount as re, watch as N } from "vue-demi";
import { openBlock as x, createElementBlock as w, normalizeStyle as R, createElementVNode as oe, Fragment as le, renderList as ae, renderSlot as de } from "vue";
const ue = "auto", q = "start", fe = "center", ce = "end", P = "vertical", D = "horizontal", me = "observed", O = "requested", he = {
  [P]: "scrollTop",
  [D]: "scrollLeft"
}, Se = {
  [P]: "height",
  [D]: "width"
}, ge = {
  [P]: "top",
  [D]: "left"
}, Ie = {
  overflow: "auto",
  willChange: "transform",
  WebkitOverflowScrolling: "touch"
}, H = {
  position: "relative",
  overflow: "hidden",
  width: "100%",
  minHeight: "100%"
}, ze = {
  position: "absolute",
  left: 0,
  width: "100%",
  height: "100%"
};
class ve {
  constructor({ itemCount: e, itemSizeGetter: n, estimatedItemSize: s }) {
    f(this, "itemSizeGetter");
    f(this, "itemCount");
    f(this, "estimatedItemSize");
    f(this, "lastMeasuredIndex");
    f(this, "itemSizeAndPositionData");
    this.itemSizeGetter = n, this.itemCount = e, this.estimatedItemSize = s, this.itemSizeAndPositionData = {}, this.lastMeasuredIndex = -1;
  }
  updateConfig({ itemCount: e, estimatedItemSize: n }) {
    this.itemCount = e, this.estimatedItemSize = n;
  }
  getLastMeasuredIndex() {
    return this.lastMeasuredIndex;
  }
  destroy() {
    for (let e in this.itemSizeAndPositionData)
      delete this.itemSizeAndPositionData[e];
  }
  /**
   * This method returns the size and position for the item at the specified index.
   * It just-in-time calculates (or used cached values) for items leading up to the index.
   */
  getSizeAndPositionForIndex(e) {
    if (e < 0 || e >= this.itemCount)
      throw Error(`Requested index ${e} is outside of range 0..${this.itemCount}`);
    if (e > this.lastMeasuredIndex) {
      const n = this.getSizeAndPositionOfLastMeasuredItem();
      let s = n.offset + n.size;
      for (let r = this.lastMeasuredIndex + 1; r <= e; r++) {
        const l = this.itemSizeGetter(r);
        if (l == null || isNaN(l))
          throw Error(`Invalid size returned for index ${r} of value ${l}`);
        this.itemSizeAndPositionData[r] = {
          offset: s,
          size: l
        }, s += l;
      }
      this.lastMeasuredIndex = e;
    }
    return this.itemSizeAndPositionData[e];
  }
  getSizeAndPositionOfLastMeasuredItem() {
    return this.lastMeasuredIndex >= 0 ? this.itemSizeAndPositionData[this.lastMeasuredIndex] : { offset: 0, size: 0 };
  }
  /**
   * Total size of all items being measured.
   * This value will be completedly estimated initially.
   * As items as measured the estimate will be updated.
   */
  getTotalSize() {
    const e = this.getSizeAndPositionOfLastMeasuredItem();
    return e.offset + e.size + (this.itemCount - this.lastMeasuredIndex - 1) * this.estimatedItemSize;
  }
  /**
   * Determines a new offset that ensures a certain item is visible, given the alignment.
   *
   * @param align Desired alignment within container; one of "start" (default), "center", or "end"
   * @param containerSize Size (width or height) of the container viewport
   * @return Offset to use to ensure the specified item is visible
   */
  getUpdatedOffsetForIndex({
    align: e = q,
    containerSize: n,
    currentOffset: s,
    targetIndex: r
  }) {
    if (n <= 0)
      return 0;
    const l = this.getSizeAndPositionForIndex(r), a = l.offset, c = a - n + l.size;
    let o;
    switch (e) {
      case ce:
        o = c;
        break;
      case fe:
        o = a - (n - l.size) / 2;
        break;
      case q:
        o = a;
        break;
      default:
        o = Math.max(c, Math.min(a, s));
    }
    const d = this.getTotalSize();
    return Math.max(0, Math.min(d - n, o));
  }
  getVisibleRange({
    containerSize: e,
    offset: n,
    overscanCount: s
  }) {
    if (this.getTotalSize() === 0)
      return {};
    const l = n + e;
    let a = this.findNearestItem(n);
    if (typeof a > "u")
      throw Error(`Invalid offset ${n} specified`);
    const c = this.getSizeAndPositionForIndex(a);
    n = c.offset + c.size;
    let o = a;
    for (; n < l && o < this.itemCount - 1; )
      o++, n += this.getSizeAndPositionForIndex(o).size;
    return s && (a = Math.max(0, a - s), o = Math.min(o + s, this.itemCount - 1)), {
      start: a,
      stop: o
    };
  }
  /**
   * Clear all cached values for items after the specified index.
   * This method should be called for any item that has changed its size.
   * It will not immediately perform any calculations; they'll be performed the next time getSizeAndPositionForIndex() is called.
   */
  resetItem(e) {
    this.lastMeasuredIndex = Math.min(this.lastMeasuredIndex, e - 1);
  }
  /**
   * Searches for the item (index) nearest the specified offset.
   *
   * If no exact match is found the next lowest item index will be returned.
   * This allows partially visible items (with offsets just before/above the fold) to be visible.
   */
  findNearestItem(e) {
    if (isNaN(e))
      throw Error(`Invalid offset ${e} specified`);
    e = Math.max(0, e);
    const n = this.getSizeAndPositionOfLastMeasuredItem(), s = Math.max(0, this.lastMeasuredIndex);
    return n.offset >= e ? this.binarySearch({
      high: s,
      low: 0,
      offset: e
    }) : this.exponentialSearch({
      index: s,
      offset: e
    });
  }
  binarySearch({ low: e, high: n, offset: s }) {
    let r = 0, l = 0;
    for (; e <= n; ) {
      if (r = e + Math.floor((n - e) / 2), l = this.getSizeAndPositionForIndex(r).offset, l === s)
        return r;
      l < s ? e = r + 1 : l > s && (n = r - 1);
    }
    return e > 0 ? e - 1 : 0;
  }
  exponentialSearch({ index: e, offset: n }) {
    let s = 1;
    for (; e < this.itemCount && this.getSizeAndPositionForIndex(e).offset < n; )
      e += s, s *= 2;
    return this.binarySearch({
      high: Math.min(e, this.itemCount - 1),
      low: Math.floor(e / 2),
      offset: n
    });
  }
}
class Ae {
  addEventListener(e, n, s) {
    return e.addEventListener ? e.addEventListener(n, s, !1) : e.attachEvent ? e.attachEvent(n, s) : e["on" + n] = s;
  }
  removeEventListener(e, n, s) {
    return e.removeEventListener ? e.removeEventListener(n, s, !1) : e.detachEvent ? e.detachEvent(n, s) : e["on" + n] = null;
  }
  isArray(e) {
    return Object.prototype.toString.call(e) === "[object Array]";
  }
  randomColor() {
    return "#" + ("00000" + (Math.random() * 16777216 << 0).toString(16)).slice(-6);
  }
  isPureNumber(e) {
    return typeof e == "number" || !e;
  }
}
class ye {
  constructor() {
    f(this, "items", []);
    f(this, "offset", 0);
    f(this, "data", null);
    f(this, "start", 0);
    f(this, "stop", 0);
    f(this, "total", 0);
  }
  toString() {
    return `start:${this.start} stop:${this.stop} total:${this.total} offset:${this.offset}`;
  }
}
const Ee = (t, e) => {
  const n = t.__vccOpts || t;
  for (const [s, r] of e)
    n[s] = r;
  return n;
}, Me = te({
  name: "InfiniteList",
  props: {
    scrollDirection: {
      type: String,
      default: P
    },
    scrollToAlignment: {
      type: String,
      default: ue
    },
    overscanCount: {
      type: Number,
      default: 4
    },
    itemSize: {
      type: null,
      required: !0
    },
    data: {
      type: [Array, null],
      default: [],
      required: !0
    },
    unit: {
      type: String,
      default: "px"
    },
    width: {
      type: [Number, String]
    },
    height: {
      type: [Number, String]
    },
    debug: {
      type: Boolean,
      default: !1
    },
    scrollOffset: Number,
    scrollToIndex: Number,
    estimatedItemSize: Number
  },
  setup(t, { attrs: e, slots: n, emit: s }) {
    let r = C(null), l = C(null), a = C(null), c = C(null), o = [], d, T, z, m, v = {};
    const { itemSize: h, scrollDirection: _, scrollToIndex: Ne } = ne(t), A = new Ae(), S = ie(new ye()), Y = (i) => {
      i += S.start;
      const u = v[i];
      if (u)
        return u;
      const { size: g, offset: J } = m.getSizeAndPositionForIndex(i), K = t.debug ? { backgroundColor: A.randomColor() } : null;
      return v[i] = {
        ...ze,
        ...K,
        [M()]: I(g),
        [ge[t.scrollDirection]]: I(J)
      };
    }, $ = () => {
      W(), A.addEventListener(r.value, "scroll", V), d = t.scrollOffset || t.scrollToIndex != null && b(t.scrollToIndex) || 0, z = O, setTimeout(() => {
        t.scrollOffset != null ? L(t.scrollOffset) : t.scrollToIndex != null && L(b(t.scrollToIndex));
      }, 0), U(), y();
    }, V = (i) => {
      const u = p();
      u < 0 || d === u || i.target !== r.value || (d = u, z = me, y());
    }, y = () => {
      const { start: i, stop: u } = m.getVisibleRange({
        containerSize: F() || 0,
        offset: d || 0,
        overscanCount: t.overscanCount
      });
      if (typeof i < "u" && typeof u < "u") {
        o.length = 0;
        for (let g = i; g <= u; g++)
          o.push(t.data[g]);
        S.start = i, S.stop = u, S.offset = d, S.items = o, S.total = E(), A.isPureNumber(h.value) || (c.value = {
          ...H,
          [M()]: I(m.getTotalSize())
        }), t.debug && console.log(S.toString());
      }
      j();
    }, L = (i) => {
      r.value[G()] = i, T = i;
    }, j = () => {
      T !== d && z === O && L(d);
    }, W = () => (m || (m = new ve({
      itemCount: E(),
      itemSizeGetter: (i) => Q(i),
      estimatedItemSize: k()
    })), m), p = () => r.value[G()], M = () => Se[_.value], F = () => t[M()], G = () => he[_.value], b = (i, u = t.scrollToAlignment, g = E()) => ((i < 0 || i >= g) && (i = 0), m.getUpdatedOffsetForIndex({
      align: t.scrollToAlignment,
      containerSize: F(),
      currentOffset: d || 0,
      targetIndex: i
    })), Q = (i) => typeof h.value == "function" ? h.value(i) : A.isArray(h.value) ? h.value[i] : h.value, E = () => t.data ? t.data.length : 0, k = () => t.estimatedItemSize || typeof h.value == "number" && h.value || 50, Z = (i = 0) => {
      v = {}, m.resetItem(i);
    }, I = (i) => typeof i == "string" ? i : i + t.unit, U = () => {
      a.value = {
        ...Ie,
        height: I(t.height),
        width: I(t.width)
      }, c.value = {
        ...H,
        [M()]: I(m.getTotalSize())
      };
    }, B = () => {
      for (let i in v)
        delete v[i];
    };
    return se(() => setTimeout($)), re(() => {
      B(), m.destroy(), A.removeEventListener(r.value, "scroll", V);
    }), N(
      () => t.debug,
      (i, u) => B()
    ), N(
      () => t.data,
      (i, u) => {
        i && $(), m.updateConfig({
          itemCount: E(),
          estimatedItemSize: k()
        }), T = null, Z(), U(), setTimeout(y, 0);
      }
    ), N(
      () => t.scrollOffset,
      (i, u) => {
        d = t.scrollOffset || 0, z = O, y();
      }
    ), N(
      () => t.scrollToIndex,
      (i, u) => {
        d = b(t.scrollToIndex, t.scrollToAlignment, E()), z = O, y();
      }
    ), {
      rootNode: r,
      innerNode: l,
      warpStyle: a,
      innerStyle: c,
      getItemStyle: Y,
      event: S
    };
  }
});
function Ce(t, e, n, s, r, l) {
  var a;
  return x(), w("div", {
    ref: "rootNode",
    style: R(t.warpStyle)
  }, [
    oe("div", {
      ref: "innerNode",
      style: R(t.innerStyle)
    }, [
      (x(!0), w(le, null, ae((a = t.event) == null ? void 0 : a.items, (c, o) => {
        var d;
        return x(), w("div", {
          style: R(t.getItemStyle(o)),
          key: ((d = t.event) == null ? void 0 : d.start) + o,
          class: "vue3-infinite-list"
        }, [
          de(t.$slots, "default", {
            event: t.event,
            item: c,
            index: t.event.start + o
          })
        ], 4);
      }), 128))
    ], 4)
  ], 4);
}
const Le = /* @__PURE__ */ Ee(Me, [["render", Ce]]);
export {
  Le as default
};
